<template>
  <q-dialog
    v-model="popupFullSize"
    persistent
    :maximized="maximizedToggle"
    transition-show="slide-up"
    transition-hide="slide-down"
    ref="dialogRef"
  >
    <q-card class="">
      <q-bar>
        <q-space />
        <q-btn
          dense
          flat
          icon="minimize"
          @click="maximizedToggle = false"
          :disable="!maximizedToggle"
        >
          <q-tooltip v-if="maximizedToggle" class="bg-white text-primary"
            >Minimize</q-tooltip
          >
        </q-btn>
        <q-btn
          dense
          flat
          icon="crop_square"
          @click="maximizedToggle = true"
          :disable="maximizedToggle"
        >
          <q-tooltip v-if="!maximizedToggle" class="bg-white text-primary"
            >Maximize</q-tooltip
          >
        </q-btn>
        <q-btn dense flat icon="close" v-close-popup>
          <q-tooltip class="bg-white text-primary">Close</q-tooltip>
        </q-btn>
      </q-bar>
      <q-card-section>
        <div class="text-h6">{{ windowObj.title }}</div>
      </q-card-section>

      <q-card-section class="q-pt-none">

        visuel des
        {{ inputNumberOfDay }}
        {{ nameThePeriodsMF(intervalInput) }}
        {{ nameThePeriods(intervalInput) }}
        <pre class="dev">{{ JSON.stringify(dataPrepare, null, 2) }}</pre>
        <pre class="dev">{{ chartWidth }}</pre>
        <Chart
          :size="{ width: width - 30, height: 420 }"
          :data="dataPrepare"
          :margin="margin"
          :direction="direction"
          :axis="axis"
        >
          <template #layers>
            <Grid strokeDasharray="2,2" />
            <Line
              v-for="item in filterField"
              :key="item._id"
              :item="item"
              :dataKeys="['name', item.name]"
              :lineStyle="{ stroke: item.color }"
              type="monotone"
            />
          </template>
          <template #widgets>
            <Tooltip
              borderColor="yellow"
              :config="{
                name: { label: 'date: ' },
              }"
            />
          </template>
        </Chart>
      </q-card-section>
      <q-card-section>
        <div class="text-h6">filtres</div>
        <div class="q-gutter-sm">
          <q-checkbox
            v-for="item in authStore.userObject.champs"
            :key="item._id"
            keep-color
            v-model="theRefForCheck[item._id]"
            :label="item.name"
            :color="item.color"
          />
        </div>
        <div class="q-pa-md">
          <br><br>
            nombre de {{ nameThePeriods(intervalInput) }} ({{ inputNumberOfDay }})
          <br><br>
          <q-slider
            v-model="inputNumberOfDay"
            color="secondary"
            :min="7"
            :max="100"
          />
          <br><br>
          {{ nameThePeriodsMF(intervalInput) }} {{ nameThePeriods(intervalInput) }} afficher
          <br><br>
          <q-date
            v-model="lastDay"
            minimal
          />
        </div>
        <div class="q-gutter-sm">
          <q-radio v-model="intervalInput" val="day" label="jour" />
          <q-radio v-model="intervalInput" val="week" label="semaine" />
          <q-radio v-model="intervalInput" val="month" label="mois" />
          <q-radio v-model="intervalInput" val="year" label="année" />
        </div>
      </q-card-section>
    </q-card>
  </q-dialog>
</template>
<script>
import {
  computed, defineComponent, onMounted, ref,
} from 'vue';
import { useQuasar, useDialogPluginComponent } from 'quasar';
import { useAuthStore } from 'src/stores/authStore.js';
import {
  Chart as ChartJS,
  Title,
  Legend,
  BarElement,
  CategoryScale,
  LinearScale,
} from 'chart.js';

import {
  Chart, Grid, Line, Tooltip,
} from 'vue3-charts';

ChartJS.register(Title, Legend, BarElement, CategoryScale, LinearScale);

import { useWindowSize } from '@vueuse/core';

import {
  theTest,
  agregateWeek,
  agregateMonth,
  agregateYear,
} from './DialogGeneralGraphicPeriods';

export default defineComponent({
  name: 'LineChart',
  components: {
    Chart,
    Grid,
    Line,
    Tooltip,
  },

  props: {
    windowObj: {
      type: Object,
      required: true,
    },
  },

  emits: [...useDialogPluginComponent.emits],

  setup(props) {
    const authStore = useAuthStore();
    const quasar = useQuasar();
    const direction = ref('horizontal');
    const margin = ref({
      left: 0,
      top: 20,
      right: 20,
      bottom: 0,
    });

    const { width/* , height */ } = useWindowSize();

    const axis = ref({
      primary: {
        type: 'band',
        format: () => '', // efface les labels des abscisses (x)
      },
      secondary: {
        domain: ['dataMin', 'dataMax'],
        type: 'linear',
        ticks: 8,
      },
    });
    const {
      dialogRef,
      onDialogHide,
    } = useDialogPluginComponent();
    const maximizedToggle = ref(true);
    const popupFullSize = ref('');

    const outpout = ref([]);

    const lastDay = ref('');
    const intervalInput = ref('day');

    async function getfieldCalendar(item) {
      popupFullSize.value = true;
      const requestOptionsConn = {
        method: 'GET',
        headers: {
          Authorization: `Bearer ${authStore.jwt}`,
        },
      };
      return fetch(
        `${import.meta.env.VITE_FETCH_BACK}/users/${authStore.userId}/champs/${
          item._id
        }/calendar`,
        requestOptionsConn,
      ).then((response) => {
        if (response.status !== 200) {
          quasar.dialog({
            title: 'Alert',
            message: 'un problème est survenu ...',
          });
          throw response.status;
        }
        return response.json();
      });
    }

    async function getChartData(champs) {
      const res = [];
      for (let index = 0; index < champs.length; index += 1) {
        const champ = champs[index];
        res.push(getfieldCalendar(champ));
      }
      outpout.value = await Promise.all(res);
    }

    // onMonted => au montage du component
    onMounted(() => {
      getChartData(authStore.userObject.champs);
    });

    function dateDay(inputDate) {
      const format = new Date(inputDate);
      const toReturn = `${format.getFullYear()}-${
        format.getMonth() + 1
      }-${format.getDate()}`;
      return toReturn;
    }

    function makeDataPrepareDay(iterateStep, nowDay, theValues) {
      const toReturn = [];
      for (let index = 0; index < iterateStep; index += 1) {
        const res = Date.parse(nowDay) - index * 24 * 60 * 60 * 1000;
        const searchDate = dateDay(res);
        const pushInToReturn = { name: searchDate };
        // nomme les champs:
        for (
          let index2 = 0;
          index2 < authStore.userObject.champs.length;
          index2 += 1
        ) {
          const theChamp = authStore.userObject.champs[index2];
          let theValue = 0;
          // donne la value au champ:
          for (let index3 = 0; index3 < theValues[index2].length; index3 += 1) {
            const element = theValues[index2][index3];
            const dateOfElement = dateDay(element.date);
            if (dateOfElement === searchDate) {
              theValue = element.value;
            }
          }
          pushInToReturn[theChamp.name] = theValue;
        }
        toReturn.unshift(pushInToReturn);
      }
      return toReturn;
    }
    function makeDataPrepare(theValues, iterateStep, lastDayIn = false, periods = 'day') {
      // console.log('periods: ', periods);
      let nowDay = new Date();
      if (lastDayIn === '' || lastDayIn === false) {
        // console.log('default calendar');
      } else {
        nowDay = new Date(lastDayIn);
      }
      let toReturn = '';
      console.log(iterateStep, nowDay, theValues);
      console.log(authStore.userObject.champs);
      if (periods === 'day') {
        toReturn = makeDataPrepareDay(iterateStep, nowDay, theValues);
      } else if (periods === 'week') {
        toReturn = agregateWeek(iterateStep, nowDay, theValues, authStore.userObject.champs);
      } else if (periods === 'month') {
        toReturn = agregateMonth(iterateStep, nowDay, theValues, authStore.userObject.champs);
      } else if (periods === 'year') {
        toReturn = agregateYear(iterateStep, nowDay, theValues, authStore.userObject.champs);
      }
      return toReturn;
    }

    const inputNumberOfDay = ref(7);

    // computed => au changement de value
    const dataPrepare = computed(() => {
      if (outpout.value.length !== 0) {
        return makeDataPrepare(
          outpout.value,
          inputNumberOfDay.value,
          lastDay.value,
          intervalInput.value,
        );
      }
      return [];
    });
    const theRefForCheck = ref({});

    onMounted(() => {
      for (
        let index = 0;
        index < authStore.userObject.champs.length;
        index += 1
      ) {
        const element = authStore.userObject.champs[index];
        theRefForCheck.value[element._id] = true;
      }
    });
    const filterField = computed(() => authStore.userObject.champs.filter(
      (champs) => theRefForCheck.value[champs._id],
    ));
    console.log(theTest);
    function nameThePeriods(periodType) {
      if (periodType === 'day') {
        return 'jours';
      } if (periodType === 'week') {
        return 'semaines';
      } if (periodType === 'month') {
        return 'mois';
      } if (periodType === 'year') {
        return 'années';
      }
    }
    function nameThePeriodsMF(periodType) {
      if (periodType === 'day' || periodType === 'month') {
        return 'derniers';
      } if (periodType === 'week' || periodType === 'year') {
        return 'dernières';
      }
    }
    return {
      dialogRef,
      onDialogHide,
      maximizedToggle,
      popupFullSize,
      ...props,

      direction,
      margin,
      axis,
      width,

      dataPrepare,
      authStore,

      theRefForCheck,
      filterField,

      inputNumberOfDay,
      lastDay,
      intervalInput,
      outpout,
      nameThePeriods,
      nameThePeriodsMF,
    };
  },
});
</script>
